//
// Created by vfs on 02.05.2024.
//

package main

import "errors"
import "time"
import "golang.org/x/crypto/bcrypt"
import "database/sql"
import _ "github.com/lib/pq"
import _ "fmt"

var Errnorecord           = errors.New("no matching record found")
var Errinvalidcredentials = errors.New("invalid credentials")
var ErrDuplicateemail     = errors.New("duplicate email")

type Account struct {
	Id int32
	Username string
	Password []byte
	Color int32
	Firstname string
	Lastname string
	Email string
	Created time.Time
}

type Usermodel struct {
	DB *sql.DB
}

func (m *Usermodel) Insert(username string, password string, firstname string, lastname string, email string) error {
	hashedpassword, err := bcrypt.GenerateFromPassword([]byte(password), 12)

	stmt := `INSERT INTO accounts (username, password, firstname, lastname, email, created) VALUES ($1, $2, $3, $4, $5, NOW());`

	_, err = m.DB.Exec(stmt, username, string(hashedpassword), firstname, lastname, email)
	if err != nil {

	}

	return nil
}

func (m *Usermodel) Get_account(id int32) (Account, error) {
	stmt := `SELECT id, username, password, color, firstname, lastname, email, created FROM accounts WHERE id = $1;`
	row := m.DB.QueryRow(stmt, id)
	var account Account
	err := row.Scan(&account.Id, &account.Username, &account.Password, &account.Color, &account.Firstname, &account.Lastname, &account.Email, &account.Created)
	if err == sql.ErrNoRows {
		return Account{}, sql.ErrNoRows
	} else if err != nil {
		return Account{}, err
	}

	return account, nil
}

func (m *Usermodel) Authenticate(username string, password string) (int32, error) {
	var id int32
	var hashedpassword []byte
	row := m.DB.QueryRow("SELECT id, password FROM accounts WHERE username = $1", username)
	err := row.Scan(&id, &hashedpassword)
	err = bcrypt.CompareHashAndPassword(hashedpassword, []byte(password))

	if err == bcrypt.ErrMismatchedHashAndPassword {
		return 0, bcrypt.ErrMismatchedHashAndPassword
	} else if err != nil {
		return 0, err
	}

	return id, nil
}
